cert.sh 12 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11
#!/usr/bin/env bash

scriptPath=${0%/*}
. "$scriptPath"/../../libs/bashhelper.sh
. "$scriptPath"/../../libs/shflags

check_tools "cryfs openssl"

usage() {
    echo "
usage:
Janek Bevendorff's avatar
Janek Bevendorff committed
12
    $(basename "$0") issue|revoke [OPTIONS]
13 14

description:
Janek Bevendorff's avatar
Janek Bevendorff committed
15
    Manage VPN client, server, and ICA certificates.
16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65

"
    exit 1
}

CMD="$1"
shift

# Define command line arguments and parse them.
if [ "$CMD" == "issue" ]; then
    DEFINE_string "cryfs_dir" "" "CryFS base dir containing the encrypted certificates." "d"
    DEFINE_string "root_cn" "" "CN of the root certificate for signing (optional)" "r"
    DEFINE_string "type" "client" "Certificate type (client | server | ca)" "t"
    DEFINE_string "common_name" "" "Common Name (CN) for the certificate" "c"
    DEFINE_string "email" "" "E-Mail address for the certificate" "e"
    DEFINE_string "csr" "" "CSR file (optional)" "s"
    DEFINE_string "out" "" "OpenVPN .ovpn config file to generate (required if --type=client)" "o"
elif [ "$CMD" == "revoke" ]; then
    DEFINE_string "cryfs_dir" "" "CryFS base dir containing the encrypted certificates." "d"
    DEFINE_string "root_cn" "" "CN of the root certificate for signing (optional)" "r"
    DEFINE_string "type" "" "Certificate type (client | server | ca)" "t"
    DEFINE_string "cert_cn" "" "CN of the certificate to revoke" "c"
fi

FLAGS_HELP=$(usage)
export FLAGS_HELP
FLAGS "$@" || exit 1  # Parse command line arguments.
eval set -- "${FLAGS_ARGV}"

export MOUNT_DIR
trap "cleanup ${MOUNT_DIR}; exit $?" INT TERM EXIT


CONF="$(dirname $0)/openssl.conf"


# ===========================================================================
#                              helper commands
# ===========================================================================

# Usage: cleanup MOUNT_DIR
cleanup() {
    if [ ! -d "$1" ]; then
        return
    fi
    logInfo "Unmounting CryFS..."
    fusermount -u "$1" &> /dev/null
    rmdir "$1"
}

66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89
# Usage: update_repository BASE_DIR
pull_repository() {
    if [ ! -d "${1}/.git" ]; then
        logError "CryFS directory is not a Git repository!"
        exit 1
    fi

    logInfo "Updating Git repository..."
    if ! (cd "$1" && git pull); then
        logError "Git update failed!"
        exit 1
    fi
}

# Usage: commit_changes BASE_DIR
commit_changes() {
    logInfo "Committing changes to Git..."
    if ! (cd "$1" && git add -A && git commit -m "-"); then
        logError "Committing changes failed!"
    fi

    logInfo "Changes committed. Please push the repository now (git push)."
}

90 91
# Usage: mount_cryfs BASE_DIR MOUNT_DIR
mount_cryfs() {
92 93 94 95 96
    if [ ! -d "$1" ]; then
        logError "CryFS directory '$1' does not exist!"
        exit 1
    fi

97 98
    logInfo "Mounting CryFS..."
    mkdir "$2"
99 100
    if ! cryfs "$1" "$2"; then
        logError "Failed to mount CryFS volume!"
101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200
        cleanup "$2"
        exit 1
    fi
}

# Usage: choose_root_cert MOUNT_DIR
choose_root_cert() {
    echo -e "\n\nPlease choose a root certificate:" >&2
    root_certs=()
    i=0
    for c in $(find "${1}/ca/" -name "*.pem"); do
        if grep -q "PRIVATE KEY" "$c"; then
            root_certs[$i]="$c"
            printf "  [%2d] $(basename $c | sed 's/\.pem$//')\n" $i >&2
            i=$(($i +1))
        fi
    done

    echo -en "\nYour choice: " >&2
    read root_cert_choice
    while [ "${root_certs[$root_cert_choice]}" == "" ]; do
        logError "Invalid choice, please enter a valid number."
        echo -en "\nYour choice: " >&2
        read root_cert_choice
    done
    echo "${root_certs[$root_cert_choice]}"
}

# Usage: generate_key OUT_FILE BITS
generate_key() {
    logInfo "Generating private key..."
    openssl genrsa -out "$1" "$2"
}

# Usage: generate_csr CONF CERT_TYPE KEY_FILE OUT_FILE CLIENT_CN CLIENT_EMAIL
generate_csr() {
    logInfo "Generating CSR..."
    openssl req -config "$1" -new -key "$3" -out "$4" -reqexts "v3_req_${2}" \
        -subj "/C=DE/ST=Thuringia/O=Webis/L=Weimar/CN=${5}/emailAddress=${6}"
}

# Usage: revoke_cert CONF CERT CA_KEY CA_CERT
revoke_cert() {
    logInfo "Revoking certificate..."
    openssl ca -config "$1" -revoke "$2" -keyfile "$3" -cert "$4"
}

# Usage: generate_crl CONF CRL_OUT CA_KEY CA_CERT
generate_crl() {
    logInfo "Creating / updating CRL..."
    openssl ca -config "$1" -gencrl -out "$2" -keyfile "$3" -cert "$4" -updatedb
    logInfo "CRL '$2' updated."
}

# Usage: sign_csr CONF CSR_IN CERT_OUT CA_KEY CA_CERT CERT_TYPE
sign_csr() {
    local validity=730
    # certificate validity in days
    if [ "$6" == "server" ]; then
        validity=1825
    elif [ "$6" == "ca" ]; then
        validity=3650
    fi

    openssl ca -config "$1" -in "$2" -out "$3" -keyfile "$4" -cert "$5" -create_serial \
        -days "$validity" -extensions "v3_cert_${6}" -notext -batch -updatedb
}

# Usage: ensure_ca_base_dir DATA_DIR
ensure_ca_base_dir() {
    if [ ! -d "$1" ]; then
        logInfo "Creating CA data dir..."
        mkdir -p "${1}/certs"
        touch "${1}/index.txt"
        echo 1000 > "${1}/crlnumber.txt"
    fi
}

# Usage: CA_CERT
resolve_ca_chain() {
    local cert_file="$1"
    local issuer

    while : ; do
        if [ ! -f "$cert_file" ]; then
            logError "Unable to find certificate for '${issuer}', CA chain may be incomplete!"
            break
        fi

        cat "$cert_file"

        issuer="$(openssl x509 -in "${cert_file}" -noout -issuer | grep -Po '(?<=CN = )[^,]+')"
        local issuer_cert_file="$(dirname "$cert_file")/${issuer}.crt"
        if [ "$(realpath $cert_file)" == "$(realpath $issuer_cert_file)" ]; then
            break
        fi
        cert_file="$issuer_cert_file"
    done
}

201
# Usage: OUT_FILE CERT CA_CERT [KEY]
202
generate_ovpn_file() {
203
    if [ "$4" != "" ]; then
204
        echo "Password to encrypt private key in .ovpn config file: " >&2
205
        local pem="$(openssl rsa -aes256 -in $4)"
206 207
        while [ "$pem" == "" ]; do
            logError "Invalid passphrase, please try again."
208
            local pem="$(openssl rsa -aes256 -in $4)"
209
        done
210
    fi
211

212 213 214
    local out_file="$1"
    if ! $(echo "$out_file" | grep -q '\.ovpn$'); then
        out_file="${out_file}.ovpn"
215
    fi
216

217 218 219 220 221 222 223 224 225 226 227 228 229 230 231
    cat <<EOL > "$out_file"
client
remote vpn.webis.de
dev tun
proto udp
port 1194
user nobody
group nobody
remote-cert-tls server

<key>
$pem
</key>

<cert>
232
$(cat "$2")
233 234 235
</cert>

<ca>
236
$(resolve_ca_chain "$3")
237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268
</ca>
EOL

    logInfo "OpenVPN config file has been written to '$1'."
}


# ===========================================================================
#                               issue command
# ===========================================================================
issue() {
    if [ "$FLAGS_cryfs_dir" == "" ]; then
        logError "--cryfs_dir is required"
        exit 1;
    fi
    if [ "$FLAGS_type" != "client" ] && [ "$FLAGS_type" != "server" ] && [ "$FLAGS_type" != "ca" ]; then
        logError "Invalid certificate type: ${FLAGS_type}"
        exit 1
    fi
    if [ "$FLAGS_common_name" == "" ]; then
        logError "--common_name is required"
        exit 1;
    fi
    if [ "$FLAGS_email" == "" ]; then
        logError "--email is required"
        exit 1;
    fi
    if [ "$FLAGS_type" == "client" ] && [ "$FLAGS_out" == "" ]; then
        logError "--out is required if --type=client"
        exit 1;
    fi

269 270
    pull_repository "${FLAGS_cryfs_dir}"

271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318
    MOUNT_DIR="${FLAGS_cryfs_dir}_mount.${RANDOM}"
    mount_cryfs "$FLAGS_cryfs_dir" "$MOUNT_DIR"

    ROOT_KEY="$FLAGS_root_cn"
    if [ "$ROOT_KEY" == "" ] || [ ! -f "$ROOT_KEY" ]; then
        ROOT_KEY="$(choose_root_cert "$MOUNT_DIR")"
        logInfo "Using '$(basename "${ROOT_KEY}" | sed 's/\.pem$//')' as the root certificate..."
    fi
    ROOT_CERT="$(echo -n "$ROOT_KEY" | sed 's/\.pem$/.crt/')"
    export CA_BASE_DIR="$(echo "$ROOT_CERT" | sed 's/\.crt$//')_Data"
    ensure_ca_base_dir "$CA_BASE_DIR"

    BITS=2048

    # use provided CSR or generate new one
    CSR="$FLAGS_csr"
    DELETE_KEY=false
    DELETE_CSR=false
    if [ "$CSR" == "" ] || [ ! -f "$CSR" ]; then
        KEY="${MOUNT_DIR}/${FLAGS_type}/${FLAGS_common_name}.pem"
        if [ -f "$KEY" ]; then
            logError "Key file ${KEY} already exists!"
            cleanup "$MOUNT_DIR"
            exit 1
        fi
        generate_key "$KEY" "$BITS"

        CSR="${MOUNT_DIR}/${FLAGS_type}/${FLAGS_common_name}.csr"
        if [ -f "$CSR" ]; then
            logError "CSR file ${CSR} already exists!"
            cleanup "$MOUNT_DIR"
            exit 1
        fi
        if ! generate_csr "$CONF" "$FLAGS_type" "$KEY" "$CSR" "$FLAGS_common_name" "$FLAGS_email"; then
            logError "CSR generation failed!"
            cleanup "$MOUNT_DIR"
            exit 1
        fi

        if [ "$FLAGS_type" == "client" ]; then
            DELETE_KEY=true
        fi
        DELETE_CSR=true
    fi

    logInfo "Signing client certificate..."
    CERT="${MOUNT_DIR}/${FLAGS_type}/${FLAGS_common_name}.crt"
    if [ -f "$CERT" ]; then
Janek Bevendorff's avatar
Janek Bevendorff committed
319
        logError "Certificate file '${FLAGS_type}/${FLAGS_common_name}.crt' already exists, please delete it before renewal!"
320 321 322 323 324 325 326 327 328 329 330 331
        cleanup "$MOUNT_DIR"
        exit 1
    fi
    if ! sign_csr "$CONF" "$CSR" "$CERT" "$ROOT_KEY" "$ROOT_CERT" "$FLAGS_type"; then
        logError "Signing failed!"
        cleanup "$MOUNT_DIR"
        exit 1
    fi

    if [ "$FLAGS_type" == "client" ]; then
        logInfo "Writing .ovpn file..."
        ROOT_CA_CERT="$(dirname $ROOT_CERT)/Webis_Root_CA.crt"
332
        generate_ovpn_file "$FLAGS_out" "$CERT" "$ROOT_CERT" "$KEY"
333 334
    fi
    if $DELETE_KEY; then
Janek Bevendorff's avatar
Janek Bevendorff committed
335
        # delete private key after generating ovpn file
336 337 338 339
        logInfo "Deleting temporary private key..."
        rm "$KEY"
    fi
    if $DELETE_CSR; then
Janek Bevendorff's avatar
Janek Bevendorff committed
340
        # delete CSR after generating ovpn file
341 342 343 344 345 346 347 348
        logInfo "Deleting temporary CSR..."
        rm "$CSR"
    fi

    CRL="$(echo -n "$ROOT_KEY" | sed 's/\.pem$/.crl/')"
    generate_crl "$CONF" "$CRL" "$ROOT_KEY" "$ROOT_CERT"

    cleanup "$MOUNT_DIR"
349
    commit_changes "${FLAGS_cryfs_dir}"
350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370
}


# ===========================================================================
#                               revoke command
# ===========================================================================

revoke() {
    if [ "$FLAGS_cryfs_dir" == "" ]; then
        logError "--cryfs_dir is required"
        exit 1;
    fi
    if [ "$FLAGS_cert_cn" == "" ]; then
        logError "--cert_cn is required"
        exit 1;
    fi
    if [ "$FLAGS_type" == "" ]; then
        logError "--type is required"
        exit 1;
    fi

371 372
    pull_repository "${FLAGS_cryfs_dir}"

373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408
    MOUNT_DIR="${FLAGS_cryfs_dir}_mount.${RANDOM}"
    mount_cryfs "$FLAGS_cryfs_dir" "$MOUNT_DIR"

    ROOT_KEY="$FLAGS_root_cn"
    if [ "$ROOT_KEY" == "" ] || [ ! -f "$ROOT_KEY" ]; then
        ROOT_KEY="$(choose_root_cert "$MOUNT_DIR")"
        logInfo "Using '$(basename "${ROOT_KEY}" | sed 's/\.pem$//')' as the root certificate..."
    fi
    ROOT_CERT="$(echo -n "$ROOT_KEY" | sed 's/\.pem$/.crt/')"
    export CA_BASE_DIR="$(echo "$ROOT_CERT" | sed 's/\.crt$//')_Data"
    ensure_ca_base_dir "$CA_BASE_DIR"

    CERT="${MOUNT_DIR}/${FLAGS_type}/${FLAGS_cert_cn}.crt"
    if [ ! -f "$CERT" ]; then
        logError "Certificate '${CERT}' does not exist."
        cleanup "$MOUNT_DIR"
        exit 1
    fi

    echo -n "Are you sure you want to revoke the ${FLAGS_type} certificate '${FLAGS_cert_cn}'? [y/N] "
    read answer
    if [ "$answer" != "y" ] && [ "$answer" != "Y" ]; then
        logError "Revocation aborted."
        cleanup "$MOUNT_DIR"
        exit 1
    fi
    if ! revoke_cert "$CONF" "$CERT" "$ROOT_KEY" "$ROOT_CERT"; then
        logError "Certificate revocation failed!"
        cleanup "$MOUNT_DIR"
        exit 1
    fi

    CRL="$(echo -n "$ROOT_KEY" | sed 's/\.pem$/.crl/')"
    generate_crl "$CONF" "$CRL" "$ROOT_KEY" "$ROOT_CERT"

    cleanup "$MOUNT_DIR"
409
    commit_changes "${FLAGS_cryfs_dir}"
410 411 412 413 414 415 416 417 418 419 420 421 422
}

# ===========================================================================
#                                 bootstrap
# ===========================================================================

if [ "$CMD" == "issue" ] || [ "$CMD" == "revoke" ]; then
    $CMD "$@"
else
    logError "Invalid command '$CMD'."
    usage
    exit 1
fi